#include <cstdio>
#include <string>
#include <queue>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <cstdlib>
#include <sstream>
#include <vector>
#include <ctime>
#define x first
#define y second
#define MAXN (1 << 5)
using namespace std;

typedef pair<int, int> pii;

int n;
int grid[MAXN][MAXN];
/***
-1 => #  (passable)
-2 => B
-3 => I
0 .. 20 => number
***/
int dx[4] = {0, 0, -1, 1};
int dy[4] = {-1, 1, 0, 0};

int cnt[MAXN*MAXN];
int used[MAXN][MAXN], amount;
vector<pii> moves;
vector<int> am;

void bfs(int x, int y) {
	memset(used, -1, sizeof(used));
	queue<int> q;
	q.push(x); q.push(y);
	used[x][y] = 0;
	amount = 1;

	while (q.size()) {
		int topx = q.front(); q.pop();
		int topy = q.front(); q.pop();

		for (int dir=0; dir < 4; ++dir) {
			int nx = topx + dx[dir];
			int ny = topy + dy[dir];
			if (nx < 0 || nx >= n) continue;
			if (ny < 0 || ny >= n) continue;
			if (grid[nx][ny] != -1) continue;
			if (used[nx][ny] != -1) continue;

			amount ++;
			used[nx][ny] = used[topx][topy]+1;
			q.push(nx);
			q.push(ny);
		}
	}
}

vector<pii> ans;
int total;

inline void print() {
	sort(ans.begin(), ans.end());
	printf("%d\n", ans.size());
	for (int i=0; i < ans.size(); ++i)
		printf("%d %d\n", ans[i].x, ans[i].y);
}

void makeMove(int x, int y) {
	ans.push_back(make_pair(x, y));
	//printf("into make a move %d %d\n", x, y);
	if (ans.size() == total) {
		print();
		exit(0);
	}
	used[x][y] = 1;

	for (int dir=0; dir < 4; ++dir) {
		int nx = x + dx[dir];
		int ny = y + dy[dir];
		if (nx < 0 || nx >= n) continue;
		if (ny < 0 || ny >= n) continue;
		if (used[nx][ny]) continue;
		if (grid[nx][ny] == -1) {
			makeMove(nx, ny);
		}
	}
}

int save[MAXN][MAXN];
int dlx[4] = {0, -1, 0, 1};
int dly[4] = {-1, 0, 1, 0};

int dux[4] = {-1, 0, 1, 0};
int duy[4] = {0, 1, 0, -1};

int drx[4] = {0, 1, 0, -1};
int dry[4] = {1, 0, -1, 0};

int ddx[4] = {1, 0, -1, 0};
int ddy[4] = {0, -1, 0, 1};


void shakeItToTheLeft(int x, int y) {
	ans.push_back(make_pair(x, y));
	//printf("into make a move %d %d\n", x, y);
	if (ans.size() == total) {
		return;
	}
	grid[x][y] = -2;
	used[x][y] = 1;

	for (int dir=0; dir < 4; ++dir) {
		int nx = x + dlx[dir];
		int ny = y + dly[dir];
		if (nx < 0 || nx >= n) continue;
		if (ny < 0 || ny >= n) continue;
		if (used[nx][ny]) continue;
		if (grid[nx][ny] == -1) {
			makeMove(nx, ny);
			if (ans.size() == total)
				return;
		}
	}
}

void shakeItToTheRight(int x, int y) {
	ans.push_back(make_pair(x, y));
	//printf("into make a move %d %d\n", x, y);
	if (ans.size() == total) {
		return;
	}
	grid[x][y] = -2;
	used[x][y] = 1;

	for (int dir=0; dir < 4; ++dir) {
		int nx = x + drx[dir];
		int ny = y + dry[dir];
		if (nx < 0 || nx >= n) continue;
		if (ny < 0 || ny >= n) continue;
		if (used[nx][ny]) continue;
		if (grid[nx][ny] == -1) {
			makeMove(nx, ny);
			if (ans.size() == total)
				return;
		}
	}
}

void shakeItUp(int x, int y) {
	ans.push_back(make_pair(x, y));
	//printf("into make a move %d %d\n", x, y);
	if (ans.size() == total) {
		return;
	}
	grid[x][y] = -2;
	used[x][y] = 1;

	for (int dir=0; dir < 4; ++dir) {
		int nx = x + dux[dir];
		int ny = y + duy[dir];
		if (nx < 0 || nx >= n) continue;
		if (ny < 0 || ny >= n) continue;
		if (used[nx][ny]) continue;
		if (grid[nx][ny] == -1) {
			makeMove(nx, ny);
			if (ans.size() == total)
				return;
		}
	}
}

void shakeItDown(int x, int y) {
	ans.push_back(make_pair(x, y));
	//printf("into make a move %d %d\n", x, y);
	if (ans.size() == total) {
		return;
	}
	grid[x][y] = -2;
	used[x][y] = 1;

	for (int dir=0; dir < 4; ++dir) {
		int nx = x + ddx[dir];
		int ny = y + ddy[dir];
		if (nx < 0 || nx >= n) continue;
		if (ny < 0 || ny >= n) continue;
		if (used[nx][ny]) continue;
		if (grid[nx][ny] == -1) {
			makeMove(nx, ny);
			if (ans.size() == total)
				return;
		}
	}
}

void shakeItAllTheTime(int x, int y) {
	memset(used, -1, sizeof(used));
	queue<int> q;
	q.push(x); q.push(y);
	used[x][y] = 0;

	while (q.size()) {
		int topx = q.front(); q.pop();
		int topy = q.front(); q.pop();

		ans.push_back(make_pair(topx, topy));
		if (ans.size() == total)
			break;

		for (int dir=0; dir < 4; ++dir) {
			int nx = topx + dx[dir];
			int ny = topy + dy[dir];
			if (nx < 0 || nx >= n) continue;
			if (ny < 0 || ny >= n) continue;
			if (grid[nx][ny] != -1) continue;
			if (used[nx][ny] != -1) continue;

			used[nx][ny] = used[topx][topy]+1;
			q.push(nx);
			q.push(ny);
		}
	}
}

inline void solve() {
	for (int i=0; i < n; ++i)
		for (int j=0; j < n; ++j)
			if (grid[i][j] == -2) { // it's marked
				for (int dir=0; dir < 4; ++dir) {
					int nx = i+dx[dir];
					int ny = j+dy[dir];
					if (nx < 0 || nx >= n) continue;
					if (ny < 0 || ny >= n) continue;
					if (grid[nx][ny] != -2) {
						grid[nx][ny] = -3; // impossibru!~
					}
				}
			}
	int available = 0;
	for (int i=0; i < n; ++i)
		for (int j=0; j < n; ++j) {
			if (grid[i][j] <= 0) continue;
			amount = 0;
			bfs(i, j);
			if (amount >= grid[i][j]) {
				available ++;
				moves.push_back(make_pair(i, j));
				am.push_back(amount);
			}
		}

	if (!available) {
		// admit your defeat
		while (1) {;}
	}

	// and now make the worst move possible
	for (int i=0; i < moves.size(); ++i) {
		for (int j=i+1; j < moves.size(); ++j) {
			if (am[j] == am[i])
				if (grid[moves[j].x][moves[j].y] > grid[moves[i].x][moves[i].y]) {
					swap(moves[i], moves[j]);
					swap(am[i], am[j]);
				}
			if (am[j] > am[i]) {
				swap(moves[i], moves[j]);
				swap(am[i], am[j]);
			}
		}
	}

	memcpy(save, grid, sizeof(grid));
	for (int idx=0, av; idx < moves.size(); ++idx) {
		int curx = moves[idx].x, cury = moves[idx].y;
		total = save[curx][cury];
		// left priority
		memcpy(grid, save, sizeof(save));
		memset(used, 0, sizeof(used));
		ans.clear();
		shakeItToTheLeft(curx, cury);
		for (int i=0; i < n; ++i)
			for (int j=0; j < n; ++j)
				if (grid[i][j] == -2) {
					for (int dir=0; dir < 4; ++dir) {
						int nx = i+dx[dir];
						int ny = j+dy[dir];
						if (nx < 0 || nx >= n) continue;
						if (ny < 0 || ny >= n) continue;
						if (grid[nx][ny] != -2) {
							grid[nx][ny] = -3; // impossibru!~
						}
					}
				}
		av = 0;
		for (int i=0; i < n; ++i)
			for (int j=0; j < n; ++j) {
				if (grid[i][j] <= 0) continue;
				amount = 0;
				bfs(i, j);
				if (amount >= grid[i][j]) {
					av ++;
					moves.push_back(make_pair(i, j));
					am.push_back(amount);
				}
			}
		if ((av & 1) == 0) {
			print();
			exit(0);
		}

		//right priority
		memcpy(grid, save, sizeof(grid));
		memset(used, 0, sizeof(used));
		ans.clear();
		shakeItToTheRight(curx, cury);
		for (int i=0; i < n; ++i)
			for (int j=0; j < n; ++j)
				if (grid[i][j] == -2) {
					for (int dir=0; dir < 4; ++dir) {
						int nx = i+dx[dir];
						int ny = j+dy[dir];
						if (nx < 0 || nx >= n) continue;
						if (ny < 0 || ny >= n) continue;
						if (grid[nx][ny] != -2) {
							grid[nx][ny] = -3; // impossibru!~
						}
					}
				}
		av = 0;
		for (int i=0; i < n; ++i)
			for (int j=0; j < n; ++j) {
				if (grid[i][j] <= 0) continue;
				amount = 0;
				bfs(i, j);
				if (amount >= grid[i][j]) {
					av ++;
					moves.push_back(make_pair(i, j));
					am.push_back(amount);
				}
			}
		if ((av & 1) == 0) {
			print();
			exit(0);
		}

		if (((double)clock() / (double)CLOCKS_PER_SEC) > 0.90)
			break;
		//up priority
		memcpy(grid, save, sizeof(grid));
		memset(used, 0, sizeof(used));
		ans.clear();
		shakeItUp(curx, cury);
		for (int i=0; i < n; ++i)
			for (int j=0; j < n; ++j)
				if (grid[i][j] == -2) {
					for (int dir=0; dir < 4; ++dir) {
						int nx = i+dx[dir];
						int ny = j+dy[dir];
						if (nx < 0 || nx >= n) continue;
						if (ny < 0 || ny >= n) continue;
						if (grid[nx][ny] != -2) {
							grid[nx][ny] = -3; // impossibru!~
						}
					}
				}
		av = 0;
		for (int i=0; i < n; ++i)
			for (int j=0; j < n; ++j) {
				if (grid[i][j] <= 0) continue;
				amount = 0;
				bfs(i, j);
				if (amount >= grid[i][j]) {
					av ++;
					moves.push_back(make_pair(i, j));
					am.push_back(amount);
				}
			}
		if ((av & 1) == 0) {
			print();
			exit(0);
		}

		//down priority
		memcpy(grid, save, sizeof(grid));
		memset(used, 0, sizeof(used));
		ans.clear();
		shakeItDown(curx, cury);
		for (int i=0; i < n; ++i)
			for (int j=0; j < n; ++j)
				if (grid[i][j] == -2) {
					for (int dir=0; dir < 4; ++dir) {
						int nx = i+dx[dir];
						int ny = j+dy[dir];
						if (nx < 0 || nx >= n) continue;
						if (ny < 0 || ny >= n) continue;
						if (grid[nx][ny] != -2) {
							grid[nx][ny] = -3; // impossibru!~
						}
					}
				}
		av = 0;
		for (int i=0; i < n; ++i)
			for (int j=0; j < n; ++j) {
				if (grid[i][j] <= 0) continue;
				amount = 0;
				bfs(i, j);
				if (amount >= grid[i][j]) {
					av ++;
					moves.push_back(make_pair(i, j));
					am.push_back(amount);
				}
			}
		if ((av & 1) == 0) {
			print();
			exit(0);
		}
		//bfs-like
		memcpy(grid, save, sizeof(grid));
		memset(used, 0, sizeof(used));
		ans.clear();
		shakeItAllTheTime(curx, cury);
		for (int i=0; i < n; ++i)
			for (int j=0; j < n; ++j)
				if (grid[i][j] == -2) {
					for (int dir=0; dir < 4; ++dir) {
						int nx = i+dx[dir];
						int ny = j+dy[dir];
						if (nx < 0 || nx >= n) continue;
						if (ny < 0 || ny >= n) continue;
						if (grid[nx][ny] != -2) {
							grid[nx][ny] = -3; // impossibru!~
						}
					}
				}
		av = 0;
		for (int i=0; i < n; ++i)
			for (int j=0; j < n; ++j) {
				if (grid[i][j] <= 0) continue;
				amount = 0;
				bfs(i, j);
				if (amount >= grid[i][j]) {
					av ++;
					moves.push_back(make_pair(i, j));
					am.push_back(amount);
				}
			}
		if ((av & 1) == 0) {
			print();
			exit(0);
		}

		if (((double)clock() / (double)CLOCKS_PER_SEC) > 0.90)
			break;
	}
	int idx = 0;
	total = grid[moves[idx].x][moves[idx].y];
	ans.clear();
	memset(used, 0, sizeof(used));
	makeMove(moves[idx].x, moves[idx].y);
}

inline void read() {
	cin >> n;
	getc(stdin);
	for (int i=0; i < n; ++i) {
		string str;
		getline(cin, str);
		stringstream ss(str);
		int j = 0;
		while (ss >> str) {
			if (str.size() == 1) {
				if (str[0] >= '0' && str[0] <= '9') { grid[i][j] = str[0]-'0'; goto next; }
				if (str[0] == '#') { grid[i][j] = -1; goto next; }
				if (str[0] == 'B') { grid[i][j] = -2; goto next; }
			} else {
				grid[i][j] = (str[0]-'0')*10 + str[1]-'0';
			}
			next:;
			++j;
		}
	}
}

int main() {
	freopen("game.in", "r", stdin);
	freopen("game.out", "w", stdout);
	read();
	/*for (int i=0; i < n; ++i) {
		for (int j=0; j < n; ++j)
			printf("%d%c", grid[i][j], (j+1 == n)?'\n':' ');
	}*/
	solve();
	return 0;
}
